
/* AMX Mod script.
*
* Ultimate sounds
*  by Hephaistos (hephaistos@djeyl.net.net)
*
*  cvar:
*   amx_streak_events < flags >
*   "a" - messages
*   "b" - sounds
*
*   amx_bomb_events < flags >
*   "a" - exploded
*   "b" - planting
*   "c" - defusing
*   "d" - planted
*   "e" - defused
*   "f" - failed to defuse
*   "g" - pickup
*   "h" - dropped
*   "i" - sounds
*
*   hekill_announce_mode < flags > 
*   "a" - show normal HE-Kill in hud 
*   "b" - show suicide HE-Kill in hud 
*   "c" - play sound on HE-Kill
*
*   Thank ToT|V!PER ,OLO ,JustinHoMi ,PsychoGuard and dJeyL for your plugins
*
*
*/





#include <amxmod>

#define KNIFFMESSAGES   4
#define HEMESSAGES   4 			/* Number of Random Messages for Normal HE Kills */
#define HESMESSAGES  4 			/* Number of Random Messages for Suicide HE Kills */
#define LEVELS 5


new planter
new defuser
new c4timer
new defusing
new Float:last_omg
new Float:last_plan
new kills[33] = {0,...};
new deaths[33] = {0,...};

new levels[5] = {3, 5, 7, 9, 10};
new sounds[5][] = {"misc/multikill", "misc/ultrakill", 
                   "misc/monsterkill", "misc/killingspree", "misc/godlike"};
new messages[5][] = {"%s: Multi-Kill!", "%s: Ultra-Kill!!!", "%s: Monster-kill!!!",
                     "%s IS ON A KILLING SPREE!!!", "%s IS GODLIKE." };


new kniffmessages[KNIFFMESSAGES][] = {
"%s sliced and diced %s",
"%s pulled out knife and gutted %s",
"%s sneaks carefully behind and knifed %s",
"%s knived %s"}

new he_messages[HEMESSAGES][] = { 
"%s sends a little gift to %s",  
"%s throws a small present to %s",  
"%s made a precision throw to %s",  
"%s got a big explosion for %s"}  		/* Random Messages for Normal HE Kills */

new hes_messages[HESMESSAGES][] = { 
"%s detonated himself with a grenade",  
"%s trys the effect of a HE Grenade",  
"%s kicked a grenade into his own ass",  
"%s explodes!"}  				/* Random Messages for Suicide HE Kills */


get_streak() {
	new streak[3]
	get_cvar_string("amx_streak_events",streak,2)
	return read_flags(streak)
}


get_bemode() {
	new bemode[10]
	get_cvar_string("amx_bomb_events",bemode,9)
	return read_flags(bemode)
}



public death_event(id) {
	new streak = get_streak()
	if ((streak&1) || (streak&2)){
    new killer = read_data(1);
    new victim = read_data(2);

    kills[killer] += 1;
    kills[victim] = 0;
    deaths[killer] = 0;
    deaths[victim] += 1;

    for (new i = 0; i < LEVELS; i++) {
        if (kills[killer] == levels[i]) {
            announce(killer, i);
            return PLUGIN_CONTINUE;
	    }
        }
    }
	return PLUGIN_CONTINUE;
}

announce(killer, level) {
	new streak = get_streak()
	if (streak&1){
    new name[32];

    get_user_name(killer, name, 32);
    set_hudmessage(0, 100, 200, 0.05, 0.65, 2, 0.02, 6.0, 0.01, 0.1, 2);
    show_hudmessage(0, messages[level], name);
	}
	if (streak&2){
    client_cmd(0, "spk %s", sounds[level]);
	}
}

public reset_hud(id) {
	new streak = get_streak()
	if (streak&1){
    if (kills[id] > levels[0]) {
        client_print(id, print_chat, 
                     "* You are on a killstreak with %d kills.", kills[id]);
    } else if (deaths[id] > 1) {
        client_print(id, print_chat, 
                     "* Take care, you are on a deathstreak with %d deaths in a row.", deaths[id]);
	}
    }
}

public client_connect(id) {
	new streak = get_streak()
	if ((streak&1) || (streak&2)){
    kills[id] = 0;
    deaths[id] = 0;
	}
}




public got_bomb(id){
	new bemode = get_bemode()
	if (bemode&1){
		planter = id
		defuser = defusing = 0
		if ((read_data(1)==2) && (last_omg < get_gametime())){
			last_omg = get_gametime() + 15.0
			new name[32]
			get_user_name(planter, name , 32)
			set_hudmessage(200, 100, 0, -1.0, 0.30, 0, 6.0, 6.0, 0.5, 0.15, 1)
			show_hudmessage(0,"Omg! %s reached the target!",name)
		}
	}
}
public bdef_g(id){
	new bemode = get_bemode()
	if (read_data(1) == 3){
		if (last_plan < get_gametime()){
			if (bemode&2){
				last_plan = get_gametime() + 15.0
				new name[32]
				set_hudmessage(200, 100, 0, -1.0, 0.30, 0, 6.0, 6.0, 0.5, 0.15, 1)
				get_user_name(planter, name , 32)
				show_hudmessage(0,"%s is planting the bomb!",name)
			}
		}
	}
	else {
		defuser = defusing = id	
		if (last_plan < get_gametime()){
			if (bemode&4){
				last_plan = get_gametime() + 15.0
				new name[32]
				set_hudmessage(200, 100, 0, -1.0, 0.30, 0, 6.0, 6.0, 0.5, 0.15, 1)
				get_user_name(defusing, name , 32)
				show_hudmessage(0,"%s is defusing the bomb :D",name)
			}
		}
	}
}
public bdef_l(id)
	defusing = 0
public disable_c4(){
	c4timer = 0
	last_plan = 0.0
	last_omg = 0.0
	remove_task(8038)
}
public bomb_planted(){
	new bemode = get_bemode()
	if (bemode&8){
		if (bemode&256){
		client_cmd(0,"spk djeyl/c4powa")
		}
		new name[32]
		get_user_name(planter, name , 32)
		set_hudmessage(200, 100, 0, -1.0, 0.30, 0, 6.0, 6.0, 0.5, 0.15, 1)
		show_hudmessage(0,"%s set us up the bomb!!!",name)
		c4timer = get_cvar_num("mp_c4timer") - 2
		set_task(1.0,"bomb_c",8038,"",0,"b")
		last_plan = 0.0
	}
}
public bomb_c(){
	if (--c4timer > 0){
		if (c4timer == 30 || c4timer == 20){
			new temp[48]
			num_to_word(c4timer,temp,48)
			client_cmd(0,"spk ^"vox/%s seconds until explosion^"",temp)
		}
		else if (c4timer < 11){
			new temp[48]
			num_to_word(c4timer,temp,48)
			client_cmd(0,"spk ^"vox/%s^"",temp)
		}
		if (defusing)
			client_print(defusing,print_center,"%d",c4timer)
	}
	else{
		remove_task(8038)
	}
}
public bomb_defused(){
	new bemode = get_bemode()
	if (bemode&16){
		if (bemode&256){
		client_cmd(0,"spk djeyl/laugh")
		}
		new name[32]
		get_user_name(defuser, name , 32)
		set_hudmessage(200, 100, 0, -1.0, 0.30, 0, 6.0, 6.0, 0.5, 0.15, 1)
		show_hudmessage(0,"%s defused the bomb!",name)
		disable_c4()
	}
}
public bomb_failure(){
	new bemode = get_bemode()
	if (bemode&32){
		if (defuser){
			if (bemode&256){
			client_cmd(0,"spk djeyl/witch")
			}
			new name[32]
			get_user_name(defuser, name , 32)
			set_hudmessage(200, 100, 0, -1.0, 0.30, 0, 6.0, 6.0, 0.5, 0.15, 1)
			show_hudmessage(0,"%s  failed to defuse the bomb...",name)
		}
	}
}
public bomb_pickup(id){
	new bemode = get_bemode()
	if (bemode&64){
		new name[32]
		get_user_name(id, name , 32)
		set_hudmessage(200, 100, 0, -1.0, 0.30, 0, 6.0, 6.0, 0.5, 0.15, 1)
		show_hudmessage(0,"%s pick up the bomb...",name)
	}
}
public bomb_drop(){
	new bemode = get_bemode()
	if (bemode&128){
		new name[32]
		get_user_name(planter, name , 32)
		set_hudmessage(200, 100, 0, -1.0, 0.30, 0, 6.0, 6.0, 0.5, 0.15, 1)
		show_hudmessage(0,"%s dropped the bomb!!!",name)
	}
}






public he_kills(){ 
   new killer_id = read_data(1) 
   new victim_id = read_data(2) 
   new killer_name[32], victim_name[33] 
    
   get_user_name(killer_id,killer_name,33) 
   get_user_name(victim_id,victim_name,33) 

   new hekmode[8] 
   get_cvar_string("hekill_announce_mode",hekmode,8) 
   new hekmode_bit = read_flags(hekmode) 

   if (hekmode_bit & 1) { 
    if (victim_id != killer_id) 
     {
	if (hekmode_bit & 4) { 
     client_cmd(0,"spk djeyl/grenade") 
	}
	set_hudmessage(200, 100, 0, -1.0, 0.30, 0, 6.0, 6.0, 0.5, 0.15, 1)
	show_hudmessage(0,he_messages[ random_num(0,HEMESSAGES-1)],killer_name,victim_name) 
     }
   } 

   if (hekmode_bit & 2) { 
    if (victim_id == killer_id)
     {
	if (hekmode_bit & 4) { 
     client_cmd(0,"spk djeyl/witch")
	}
	set_hudmessage(200, 100, 0, -1.0, 0.30, 0, 6.0, 6.0, 0.5, 0.15, 1)
	show_hudmessage(0,hes_messages[ random_num(0,HESMESSAGES-1) ],victim_name) 
     } 
   }

}






public knife_kill(){
   new killer_id = read_data(1)
   new victim_id = read_data(2)
   new killer_name[33], victim_name[33]

   get_user_name(killer_id,killer_name,33)
   get_user_name(victim_id,victim_name,33)

   set_hudmessage(200, 100, 0, -1.0, 0.30, 0, 6.0, 6.0, 0.5, 0.15, 1)
   show_hudmessage(0,kniffmessages[ random_num(0,KNIFFMESSAGES-1) ],killer_name,victim_name)

   client_cmd(0,"spk misc/humiliation")
}





public hs(){
   new killer_id = read_data(1)
   new victim_id = read_data(2)
   new victim_name[33]

   get_user_name(victim_id,victim_name,33)

   set_hudmessage(200, 100, 0, -1.0, 0.30, 0, 3.0, 3.0, 0.15, 0.15, 1)
   show_hudmessage(killer_id,"::HEADSHOT::^nYou oWnEd %s !!",victim_name)
   client_cmd(0,"spk misc/headshot")
}

public plugin_precache()
{
    precache_sound( "djeyl/c4powa.wav")
    precache_sound( "djeyl/laugh.wav")
    precache_sound( "djeyl/grenade.wav")
    precache_sound( "djeyl/witch.wav")
    precache_sound( "misc/monsterkill")
    precache_sound( "misc/godlike")
    precache_sound( "misc/headshot")
    precache_sound( "misc/humiliation")
    precache_sound( "misc/killingspree")
    precache_sound( "misc/multikill")
    precache_sound( "misc/ultrakill")
    return PLUGIN_CONTINUE 
}



public plugin_init() {
   register_plugin("Ultimate sound","0.73","hephaistos@djeyl.net")
   register_event("DeathMsg","hs","a","3=1")
   register_event("DeathMsg","knife_kill","a","4&kni")
   register_event("DeathMsg","he_kills","a","4&gren") 
   register_event("StatusIcon", "got_bomb", "be", "1=1", "1=2", "2=c4")
   register_event("SendAudio", "bomb_planted", "a", "2&%!MRAD_BOMBPL")
   register_event("SendAudio", "bomb_defused", "a", "2&%!MRAD_BOMBDEF")
   register_event("TextMsg", "bomb_failure", "a", "2&#Target_B")
   register_event("BarTime", "bdef_g", "be", "1=10", "1=5","1=3")
   register_event("BarTime", "bdef_l", "be", "1=0")
   register_event("TextMsg", "bomb_pickup", "bc", "2&#Got_bomb")
   register_event("TextMsg", "bomb_drop", "bc", "2&#Game_bomb_d")
   register_event("SendAudio", "disable_c4", "a", "2&%!MRAD_terwin","2&%!MRAD_ctwin","2&%!MRAD_rounddraw")
   register_event("TextMsg","disable_c4","a","2&#Game_C","2&#Game_w") 
   register_event("ResetHUD", "reset_hud", "b");
   register_event("DeathMsg", "death_event", "a")
   register_cvar("amx_streak_events","ab")
   register_cvar("amx_bomb_events","abcdefghi")
   register_cvar("hekill_announce_mode","abc")
   return PLUGIN_CONTINUE
}
